.Const

IDC_EDIT        Equ 3000
IDC_BUTTON      Equ 3001
IDC_EXIT        Equ 3002
IDM_GETTEXT     Equ 32000
IDM_CLEAR       Equ 32001
IDM_EXIT        Equ 32002

.Data?

szBuffer		Byte 512 Dup(?)  ; buffer to store the string to output

.Data

szCRLF			Byte 13, 10, 0   ; carriage return and line feed

.Code

DivisionProcedure Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	.If uMsg == WM_CREATE

		Return TRUE
	.ElseIf uMsg == WM_COMMAND
		LoWord wParam ;Get the low word of wParam
		.If Ax == IDC_DIVISION_DIVIDEBUTTON
			HiWord wParam ;Get the high word of wParam
			.If Ax == BN_CLICKED
				;Divide button has been clicked
				Invoke DoDivision, hWnd, uMsg, wParam, lParam
				Return TRUE
			.EndIf
		.ElseIf Ax == IDC_DIVISION_CLEARBUTTON
			HiWord wParam ;Get the high word of wParam
			.If Ax == BN_CLICKED
				;Clear button has been clicked

				;Get the handle for the Edit control
				Invoke GetWindowItem, hWnd, IDC_DIVISION_GETDIVIDEND
				;Set Edit control to no text
				Invoke SetWindowText, Eax, NULL

				;Get the handle for the Edit control
				Invoke GetWindowItem, hWnd, IDC_DIVISION_GETDIVISOR
				;Set Edit control to no text
				Invoke SetWindowText, Eax, NULL

				;Get the handle for the Results static control
				Invoke GetWindowItem, hWnd, IDC_DIVISION_RESULTS
				;Set the Results static control to no text
				Invoke SetWindowText, Eax, NULL
				Return TRUE
			.EndIf
		.ElseIf Ax == IDC_DIVISION_EXITBUTTON
			HiWord wParam ;Get the high word of wParam
			.If Ax == BN_CLICKED
				;Exit button has been clicked
				Invoke SendMessage, hWnd, WM_CLOSE, 0, 0
				Return TRUE
			.EndIf
		.EndIf
	.ElseIf uMsg == WM_CLOSE
		Invoke IsModal, hWnd
		.If Eax
			Invoke EndModal, hWnd, IDCANCEL
			Return TRUE
		.EndIf
	.EndIf
	Return FALSE
DivisionProcedure EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  DoDivision procedure will calculate the quotient and the remainder       <<
;<<  of the dividend and divisor entered by the user and output the results.  <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DoDivision Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Local NumberA:DWord
	Local NumberB:DWord
	Local Quotient:DWord
	Local Remainder:DWord
    Local szNumber1[50]:CHAR
    Local szNumber2[50]:CHAR
    ; NumberA is the dividend number entered by user
    ; NumberB is the divisor number entered by user
    ; Quotient is the number result by dividing the dividend by divisor
    ; Remainder is the difference of the dividend and the product of
    ;    divisor and quotient
    ; szNumber1 is the buffer to convert the string of dividend integer string
    ;    to a integer value for dividend
    ; szNumber2 is the buffer to convert the string of divisor integer string
    ;    to a integer value for divisor


	;Get the handle to Divide button in Eax
	Invoke GetWindowItem, hWnd, IDC_DIVISION_GETDIVIDEND

	;Save it in Edx
	Mov Edx, Eax

	;Get the text in the Edit control
	Invoke GetWindowText, Edx, Addr szNumber1, 24

	;Convert it to a number returned in Eax
	Invoke Value, Addr szNumber1

	;Set the value in NumberA
	Mov NumberA, Eax

	;Get the handle to Divide button in Eax
	Invoke GetWindowItem, hWnd, IDC_DIVISION_GETDIVISOR

	;Save it in Edx
	Mov Edx, Eax

	;Get the text in the Edit control
	Invoke GetWindowText, Edx, Addr szNumber2, 24

	;Convert it to a number returned in Eax
	Invoke Value, Addr szNumber2

	;Set the value in NumberA
	Mov NumberB, Eax

    .If (NumberB != 0) ; if (NumberB = Divisor) is not equal to zero then

	  ;Get the handle to Results Static control in Eax
      Invoke GetWindowItem, hWnd, IDC_DIVISION_RESULTS

	  ;Save it in Edi
	  Mov Edi, Eax

	  ;Clear the Results control
	  Invoke SetWindowText, Edi, NULL

	  ;Clear szbuffer
	  Mov szBuffer[0], 0

	  Invoke GetWindowText, Edi, Addr szBuffer, 255
	  Invoke SetWindowText, Edi, Addr szBuffer

      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer

      Invoke lstrcat, Addr szBuffer, TextAddr(" Quotient  =   ")

      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer

      ;Convert the NumberA value to a decimal
	  ;string and adds it to szBuffer
      Invoke String, NumberA, Eax, ecDecimal

      ;output the division sign
      Invoke lstrcat, Addr szBuffer, TextAddr(" / ")

      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer

      ;Convert the NumberB value to a decimal
      ;string and adds it to szBuffer
      Invoke String, NumberB, Eax, ecDecimal

      ;Adds a carriage return/line feed to szBuffer
      Invoke lstrcat, Addr szBuffer, Addr szCRLF

      Invoke lstrcat, Addr szBuffer, TextAddr(" Quotient  =   ")

      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer

      Invoke calculateDiv, NumberA, NumberB ; Quotient = NumberA div NumberB
      Mov Quotient, Eax                     ; Quotient = Dividend div Divisor
                                            ; set Quotient = Eax

      ;Get the address of last character of szBuffer
	  Invoke lstrlen, Addr szBuffer
	  Add Eax, Offset szBuffer

      ;Convert the Quotient value to a decimal
      ;string and adds it to szBuffer
      Invoke String, Quotient, Eax, ecDecimal

      ;Adds a carriage return/line feed to szBuffer
	  Invoke lstrcat, Addr szBuffer, Addr szCRLF
      ;Adds a carriage return/line feed to szBuffer
	  Invoke lstrcat, Addr szBuffer, Addr szCRLF

	  Invoke lstrcat, Addr szBuffer, TextAddr(" Remainder  =   ")

      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer

	  ;Convert the NumberA value to a decimal
	  ;string and adds it to szBuffer
      Invoke String, NumberA, Eax, ecDecimal

      ;output the subtraction sign
	  Invoke lstrcat, Addr szBuffer, TextAddr("  ---  ")

	  ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer

	  ;Convert the NumberB value to a decimal
	  ;string and adds it to szBuffer
      Invoke String, NumberB, Eax, ecDecimal

      ;output the multiplication sign
      Invoke lstrcat, Addr szBuffer, TextAddr("  x  ")

      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer

      ;Convert the Quotient value to a decimal
      ;string and adds it to szBuffer
      Invoke String, Quotient, Eax, ecDecimal

      ;Adds a carriage return/line feed to szBuffer
	  Invoke lstrcat, Addr szBuffer, Addr szCRLF

      Invoke lstrcat, Addr szBuffer, TextAddr(" Remainder  =   ")

      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer

	  Invoke calculateMod, NumberA, NumberB ; Remainder = NumberA mod NumberB
      Mov Remainder, Eax                    ; Remainder = Dividend mod Divisor
                                            ; set Remainder = Eax

      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
	  Add Eax, Offset szBuffer

      ;Convert the Remainder value to a decimal
      ;string and adds it to szBuffer
      Invoke String, Remainder, Eax, ecDecimal

    .ElseIf (NumberB == 0) ; if (NumberB = Divisor) equals to zero then error
      Invoke MessageBox, hWnd, TextAddr("Error Division By Zero!"), TextAddr("Division"), MB_ICONEXCLAMATION Or MB_OK
      Ret
    .EndIf

    ;Get the handle to Results Static control in Eax
    Invoke GetWindowItem, hWnd, IDC_DIVISION_RESULTS
    Invoke SetWindowText, Eax, Addr szBuffer
   Ret
DoDivision EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  calculateDiv function will return the quotient = Dividend div Divisor  <<
;<<  in Eax register.                                                       <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

calculateDiv Proc Dividend:DWord, Divisor:DWord
  Local Quotient:DWord
  ; Quotient is the number result from dividing Dividend by Divisor

  Mov Eax, Dividend   ; set Eax = Dividend
  Mov Ebx, Divisor    ; set Ebx = Divisor
  Cdq                 ; convert to double quad word or 64-bit long word
  IDiv Ebx             ; Eax = Eax / Ebx
  Mov Quotient, Eax   ; set Quotient = Eax
                      ; Quotient = Dividend / Divisor
  Mov Eax, Quotient   ; return Quotient value for calculateDiv function

  Ret
calculateDiv EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  calculateMod function will return the remainder = Dividend mod Divisor <<
;<<  in Eax register.                                                       <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

calculateMod Proc Dividend:DWord, Divisor:DWord
  Local Remainder:DWord
  ; Remainder is the difference of the dividend and the product of
  ; divisor and quotient

  Mov Eax, Dividend   ; set Eax = Dividend
  Cdq                 ; convert to double quad word or 64-bit long word
  Mov Ebx, Divisor    ; set Ebx = Divisor
  IDiv Ebx             ; Eax = Eax / Ebx, Edx contains the remainder
       	              ; Edx = remainder
  Mov Remainder, Edx  ; set Remainder = Edx
       	              ; Remainder = Dividend mod Divisor
  Mov Eax, Remainder  ; return Remainder value for calculateMod function

  Ret
calculateMod EndP